/** Functionality to parse incoming messages. */
// *** AUTOGENERATED FILE - Do not edit manually! - Changes will be overwritten! *** //

#pragma once

#include <stddef.h>
#include "generated/units.h"
#include "generated/sharedTypes.h"
#include "generated/bufferAccessor.h"

#ifdef __cplusplus
extern "C" {
#endif

/** An error during parsing of a message. */
typedef enum {
    /** The message type was not recognized. */
    INVALID_MESSAGE,

    /** The checksum of the message was invalid. */
    CHECKSUM_ERROR,

    /** A dynamic size was too large. */
    DYNAMIC_SIZE_TOO_LARGE,
} ParserError;


/** A handler of parsed messages. */
typedef struct MessageHandler {
    /**
     * Handle a HEARTBEAT message.
     *
     * @param handler The message handler.
     * @param time The time the heartbeat was generated in milliseconds since boot.
     */
    void (*handleMessageHeartbeat)(struct MessageHandler* handler, ms_t time);

    /**
     * Handle a RESPONSE message.
     *
     * @param handler The message handler.
     * @param commandNumber The counter number of the command that generated this response.
     * @param value The response value of the command.
     */
    void (*handleMessageResponse)(struct MessageHandler* handler, uint8_t commandNumber,
        const uint8_t* value);

    /**
     * Handle a ACKNOWLEDGE message.
     *
     * @param handler The message handler.
     * @param commandNumber The counter number of the command that this telemetry acknowledges.
     */
    void (*handleMessageAcknowledge)(struct MessageHandler* handler, uint8_t commandNumber);

    /**
     * Handle a MESSAGE message.
     *
     * @param handler The message handler.
     * @param time The time the message was generated in milliseconds since the boot.
     * @param type The type of the message.
     * @param size The size of the message in bytes.
     * @param message The message text.
     */
    void (*handleMessageMessage)(struct MessageHandler* handler, ms_t time, MessageType type,
        uint16_t size, const char* message);

    /**
     * Handle a DATA1 message.
     *
     * @param handler The message handler.
     * @param time The current system time in milliseconds since boot.
     * @param processorTemperature The temperature of the processor in °C.
     * @param batteryTemperature The temperature read from the thermal sensor which close to the
     *                           battery in °C.
     * @param PduPcbTemperature The temperature read from the thermal sensor which close to the PDU
     *                          PCB in °C.
     * @param motorControllerTemperature The temperature read from the thermal sensor which close to
     *                                   the motor controllers in
     *                                   °C.
     * @param motorBracketTemperature The temperature read from the thermal sensor which close to
     *                                the motor bracket in °C.
     * @param retentionWallTemperature The temperature read from the thermal sensor which close to
     *                                 the retention wall in °C.
     * @param recoveryWallTemperature The temperature read from the thermal sensor which close to
     *                                the recovery wall in °C.
     * @param primaryImuTemperature The temperature of the primary IMU in °C.
     * @param secondaryImuTemperature The temperature of the secondary IMU in °C.
     * @param motorCurrent The current drawn by the motors in ampere.
     * @param secondaryImuRotation The rotations in radians per seconds measured by the secondary
     *                             IMU.
     */
    void (*handleMessageData1)(struct MessageHandler* handler, ms_t time,
        celsius_t processorTemperature, celsius_t batteryTemperature, celsius_t PduPcbTemperature,
        celsius_t motorControllerTemperature, celsius_t motorBracketTemperature,
        celsius_t retentionWallTemperature, celsius_t recoveryWallTemperature,
        celsiusInt8_t primaryImuTemperature, celsiusInt8_t secondaryImuTemperature,
        const Vec3F* motorCurrent, const Vec3F* secondaryImuRotation);

    /**
     * Handle a DATA2 message.
     *
     * @param handler The message handler.
     * @param time The current system time in milliseconds since boot.
     * @param primaryXAcceleration The acceleration on the x (roll) axis in meters per second
     *                             squared measured by the primary IMU.
     * @param primaryYAcceleration The acceleration on the y (pitch) axis in meters per second
     *                             squared measured by the primary IMU.
     * @param primaryZAcceleration The acceleration on the z (yaw) axis in meters per second squared
     *                             measured by the primary IMU.
     * @param primaryXMagneticForce The magnetic force on the x (roll) axis in micro Tesla measured
     *                              by the primary IMU.
     * @param primaryYMagneticForce The magnetic force on the y (pitch) axis in micro Tesla measured
     *                              by the primary IMU.
     * @param primaryZMagneticForce The magnetic force on the z (yaw) axis in micro Tesla measured
     *                              by the primary IMU.
     * @param secondaryXAcceleration The acceleration on the x (roll) axis in meters per second
     *                               squared measured by the secondary
     *                               IMU.
     * @param secondaryYAcceleration The acceleration on the y (pitch) axis in meters per second
     *                               squared measured by the secondary
     *                               IMU.
     * @param secondaryZAcceleration The acceleration on the z (yaw) axis in meters per second
     *                               squared measured by the secondary
     *                               IMU.
     * @param secondaryXMagneticForce The magnetic force on the x (roll) axis in micro Tesla
     *                                measured by the secondary IMU.
     * @param secondaryYMagneticForce The magnetic force on the y (pitch) axis in micro Tesla
     *                                measured by the secondary IMU.
     * @param secondaryZMagneticForce The magnetic force on the z (yaw) axis in micro Tesla measured
     *                                by the secondary IMU.
     * @param pressure The current pressure in bar.
     * @param state The current state of the system state machine.
     */
    void (*handleMessageData2)(struct MessageHandler* handler, ms_t time,
        mps2_t primaryXAcceleration, mps2_t primaryYAcceleration, mps2_t primaryZAcceleration,
        microTesla_t primaryXMagneticForce, microTesla_t primaryYMagneticForce,
        microTesla_t primaryZMagneticForce, mps2_t secondaryXAcceleration,
        mps2_t secondaryYAcceleration, mps2_t secondaryZAcceleration,
        microTesla_t secondaryXMagneticForce, microTesla_t secondaryYMagneticForce,
        microTesla_t secondaryZMagneticForce, bar_t pressure, SystemState state);

    /**
     * Handle a DATA3 message.
     *
     * @param handler The message handler.
     * @param time The current system time in milliseconds since boot.
     * @param orientation The current orientation calculated by the primary IMU using sensor fusion.
     * @param batteryLevel The voltage level of the FFU battery in volt.
     */
    void (*handleMessageData3)(struct MessageHandler* handler, ms_t time,
        const Quaternion* orientation, voltFloat_t batteryLevel);

    /**
     * Handle a DATA_MOTOR_SPEEDS message.
     *
     * @param handler The message handler.
     * @param motorSpeedCount The number of motor speeds in this telemetry package.
     * @param motorSpeeds The speed of the motors in rotations per minute since the last telemetry
     *                    package.
     */
    void (*handleMessageDataMotorSpeeds)(struct MessageHandler* handler, uint8_t motorSpeedCount,
        const Vec3FWithTime* motorSpeeds);

    /**
     * Handle a DATA_ROTATION_SPEEDS message.
     *
     * @param handler The message handler.
     * @param rotationSpeedCount The number of rotation speeds in this telemetry package.
     * @param rotationSpeeds The measured rotations in radians per seconds by the primary IMU since
     *                       the last telemetry package.
     */
    void (*handleMessageDataRotationSpeeds)(struct MessageHandler* handler,
        uint8_t rotationSpeedCount, const Vec3FWithTime* rotationSpeeds);

    /**
     * Handle a DATA_SET_POINTS message.
     *
     * @param handler The message handler.
     * @param setPointsCount The number of set points in this telemetry package.
     * @param setPoints The targeted motor speeds in rotations per minute generated by the
     *                  controller with time stamps since the last telemetry.
     */
    void (*handleMessageDataSetPoints)(struct MessageHandler* handler, uint8_t setPointsCount,
        const Vec3Int32WithTime* setPoints);

    /**
     * Handle a DATA_RECOVERY message.
     *
     * @param handler The message handler.
     * @param time The current system time in milliseconds since boot.
     * @param gpsTime The GPS time of week of the navigation epoch in milliseconds.
     * @param longitude Longitude in degrees.
     * @param latitude Latitude in degrees.
     * @param height The height above the ellipsoid in meter.
     * @param recoveryState The current state of the recovery system.
     */
    void (*handleMessageDataRecovery)(struct MessageHandler* handler, ms_t time, ms_t gpsTime,
        deg_t longitude, deg_t latitude, meter_t height, RecoveryState recoveryState);

    /**
     * Handle an error during parsing of a message.
     *
     * @param handler The message handler.
     * @param error The error that occurred.
     */
    void (*errorHandler)(struct MessageHandler* handler, ParserError error);

    /** Private data of the message handler. */
    void* data;
} MessageHandler;


/**
 * Parse and handle a received message.
 *
 * @param buffer An accessor to a buffer to parse a message from.
 * @param handler An handler for parsed messages.
 * @return Whether the message was parsed and handled.
 */
extern bool parseMessage(BufferAccessor* buffer, MessageHandler* handler);

#ifdef __cplusplus
}
#endif
